<template>
  <div>
    <div class="title-components">Search Management</div>
    <search :taskProject="taskProject" :taskUser="taskUser" @search='loadData'></search>
    <list :items="items"  @search="loadData"></list>
  </div>
</template>

<script>    

import List from '../../components/List.vue';
import callApi from '../../middleware/apiCaller.js'
import Search from '../../components/Search.vue'
import moment from 'moment'
var urlstartat=''
var urlendat=''

export default {
  data(){
    return{
      condition:null,
      items:[],
      taskUser:[],
      taskProject:[]
      
    }
  },  

  components: {
    List,
    Search
  },

  mounted() {

     // call API from server
      callApi('user','GET').then(res =>{
        this.taskUser=res.data
      })  

      // call API from server
      callApi('project','GET').then(res =>{
        this.taskProject=res.data
      })
    
    const condition = {
      project:'',
      user:'',
      status:'',
      startat:moment().startOf('month').format('YYYY-MM-DD'),
      endat:moment().endOf('month').format('YYYY-MM-DD'),
    }

    this.loadData(condition)
  },

  methods: {

    // loadData(){

    //   const startat = moment().startOf('month').format('YYYY-MM-DD')
    //   const endat = moment().endOf('month').format('YYYY-MM-DD')
    //   callApi('overtime/?_sort=id&_order=desc&startat_gte='+startat+'&endat_lte='+endat, 'GET',null).then(res =>{
    //         this.items=res.data
    //   }) 
    // },

    //function search 
    loadData(condition = null){
      let tasks = {}
      if(condition === null) {
        tasks = this.condition
      }
      else{
        tasks = condition
        this.condition = condition
      }

      let urlproject=''
      let urluser=''
      let urlstatus =''
      let url ='overtime/?_sort=id&_order=desc&'

      if(tasks.project !==''){
        url = url + 'project=' + tasks.project + "&"
      }
  
      if(tasks.user !==''){
          url = url + 'user=' + tasks.user + "&"
       }

      if(tasks.status !==''){
         url = url + 'status=' + tasks.status + "&"
      }

      if(tasks.startat!=''){
        url = url + 'startat_gte=' + tasks.startat + "&"
      }

      if(tasks.endat!=''){
        url = url + 'endat_lte=' + tasks.endat + "&"
      }
      
      callApi(url, 'GET',null).then(res =>{
        this.items=res.data
      })        
    },
  },
}
</script>

<style>
.title {
  font-family: 'Quicksand', 'Source Sans Pro', -apple-system, BlinkMacSystemFont,
    'Segoe UI', Roboto, 'Helvetica Neue', Arial, sans-serif;
  display: block;
  font-weight: 300;
  font-size: 100px;
  color: #35495e;
  letter-spacing: 1px;
}
 .demo-input-label {
    display: inline-block;
    margin-top:3px;
  }
  .group-search{
    margin-bottom: 5px;
  }

</style>